@startuml
title KitchenJob Contructor
entity Caller

participant "KitchenJob" as kj
participant "tags: List<Tag>" as tl
participant "dependencies: List<KitchenJob>" as dl
participant "ingredients: List<Dosage>" as il
participant "groupStep: GroupStep" as gs
participant "childrens: List<GenericStep>" as gsl

  Caller --> kj **: createKitchenJob(name, user, isRecipe)
    activate kj
    kj -> kj: setOwner(user)
    kj -> kj: setName(name)
    kj -> kj: setIsRecipe(isRecipe)
    kj -> kj: setPublished(false)
    kj --> gs **: createGroupStep(false, 1)
      activate gs
      gs -> gs: setAlternativeSteps(false)
      gs -> gs: setRepetitions(1)
      gs --> gsl**: create
      gs -->> kj--: groupStep
    kj -> kj: setRootGroup(groupStep)
    kj --> tl**: create
    kj --> dl**: create
    kj --> il**: create
    kj -->> Caller --: kitchenJob

@enduml
